#include<iostream>
#include<fstream>
using namespace std;

#include"defo.h"
#include"kspoinc.h"
#include"vfkso.h"
#include"multiint.h"
#include"coordc.h"
#include"ksinclpo.h"
// InclKSR_PMap


void InclKSR_PMap::initInclKSR_PMap(InclOde *ppode,GeneralLinearSection *ppsection,
                int psecdir, int pdestroy_section)
// an auxliary function used in the constructor
{
  dim=ppode->dim-1;
  pode=ppode;

  pInsection= ppsection;
  destroy_Insection=pdestroy_section;


  intervalmatrix1 *R;
  R=new intervalmatrix1[pode->dim+1];
  kssymmmatrix(R,pode->dim);  //   R: a_{2k} ->a_{2k} and a_{2k+1} -> -a_{2k+1}
  LinCC *kssymCC=new  LinCC(ppode->dim,R,R);
  delete [] R;
  R=NULL;

  LinCC *pOutCC=composeLinCC(pInsection->plincc,kssymCC);

  int pdestroyLinCC=1;
  pOutsection=new GeneralLinearSection(pOutCC,pdestroyLinCC);
  destroy_Outsection=1;



  delete kssymCC;
  kssymCC=NULL;

  secdir=psecdir; // because the return to the section will be via symmetry
                  // hence it is the same as for the initial section

}


InclKSR_PMap::InclKSR_PMap(InclOde *ppode,GeneralLinearSection *ppsection,int psecdir,
        InclPoincareParType & pparam,int pdestroy_section /*=0*/)
{
  param=pparam;
  initInclKSR_PMap(ppode,ppsection,psecdir,pdestroy_section);
}

int InclKSR_PMap::imapCCE(Set &x, SetWithTail & y,interval fx[],SetWithTail & fy,
               int coordOnInput,LinCC* inputcoordch,int coordOnOutput,
               LinCC* outputcoordch, estimates *estm)
       //   on output: f((x + C*r0) \times y) = fx \times fy
       // usually this is Poincare map
       //  It makes sense sometimes to play with different coordinate
       //  systems
       //   if (coordOnInput) then the output (x-variable) is expressed
       //   using the other coordinate  (linear) system  given by inputcoordch
       //
       //   if (coordOnOutput) then fx is given in coordinates <outputcoorch>
       // this function  assumes that the coordinates on section z[1]=0
       //  are (z[2],...) - where z - are the coordinates in this->psection->plincc
// this function is almost the same as the coresponding parent function
// in InclPoincareMap - the difference is the coordinate frame in image
{
  int retval=this->InclPoincareMap::imapCCE(x,y,fx,fy,coordOnInput,inputcoordch,
                 coordOnOutput,outputcoordch,estm);
  if(retval){
   (fy.ptail)->kssymm(); // we apply symmetry to tail
  }
  return retval;
}




