#ifndef _kspoinc_h
#define _kspoinc_h
#include"defo.h"
#include"section.h"
#include"vfkso.h"


class  KSR_PMap: public FPoincareMap
// this class is designed for an investigation of the symmetric
//  periodic orbits, which have a good projection onto 1-3 variables
//   for mu around 0.02 - 0.13
//   this is a half of the Poincare map composed with the reflectional symmetry
// which leaves even modes unchanged and on odd modes it changes sign
{
  protected:
 // inherited from FPoincareMap
//    GeneralLinearSection *pInsection; // this is the starting section
//    GeneralLinearSection *pOutsection; // the is the end section
//    int secdir;  // UP  or DOWN - this is the direction both for
//                      starting section in the function transporttosection
//                      as well for the end section for the half-Poincare
//                         map - which is given by psym_section
//    FPoincareMap_param param; // param.par_double - used for nonrigorous
                       // computations;
                       //  param.par_interval - for rigorous computations
//     int destroy_Insection,destroy_Outsection; // is 1, when the constructor
                    // created the section and then the destructor has to destroy it


  public:
    // int dim; // inherited from Fmap (and Map)
    //  Ode *pode;


// inherited:    int transporttosection(double x0full[],double fxsec[]);
    // on output fxsec is the point on the section (in the section coordinates)
    //    which is on first intersection of the trajectory through the point
    //   <x0full> which is given in standard ambient space coordinates
    // 1 - is returned if the Poincare time for x0full < tmax



    KSR_PMap(KuraShi *pkurashi,GeneralLinearSection *ppsection,
         int psecdir,Par_Poincare &pparaminterval, Par_Poincare &pparamdouble,
           int pdestroy_section =0 );

  private:
    void initsections(KuraShi *pkurashi,GeneralLinearSection *ppsection,
         int psecdir, int pdestroy_section);

};


GeneralLinearSection *kscreateGLS13(int dim,double rad13dir[]);
GeneralLinearSection *kscreateGLS13(int dim,interval rad13dir[]);
// rad13dir - is an 2-dim radial vector
  //  the flow is apparently in clockwise direction
// we need to construct the section
//  have to find  coordinates (y_1,y_2,\dots) such that
//  so that the section will be given by y_1=0, (to have y_1'>0 one needs to later sec_dir=UP)
// in our construction y_1 - is the section form and y_2 - is orthogonal form to y_1
//    y_3=x_2,  y_i=x_i for i=4,\dots

KSR_PMap* createHPKS13(KuraShi *pkurashi,interval rad13dir[],
       Par_Poincare &paraminterval, Par_Poincare &paramdouble);
//  we create a half Poincare map for (old) sections : defined in terms of 1 and 3 mode
  // rad13dir - is an 2-dim radial vector
  //  the flow is apparently in clockwise direction


#endif // _kspoinc_h
